<?php

include '../../../wp-load.php';

$options = get_option('premium_contents');

error_log(print_r($_REQUEST, true));

function pcontents_paypal_verify() {

    $options = get_option('premium_contents');

    $post_body = 'cmd=_notify-validate&';
    foreach ($_POST as $name => $value) {
        $post_body .= $name . '=' . urlencode(stripslashes($value)) . '&';
    }
    $post_body = substr($post_body, 0, -1);

    $ch = curl_init();
    curl_setopt($ch, CURLOPT_URL, 'https://www.paypal.com/cgi-bin/webscr');
    curl_setopt($ch, CURLOPT_VERBOSE, 1);

    //turning off the server and peer verification(TrustManager Concept).
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_POST, 1);

    //setting the nvpreq as POST FIELD to curl
    curl_setopt($ch, CURLOPT_POSTFIELDS, $post_body);

    //getting response from server
    $response = curl_exec($ch);

    error_log($response);

    if ($response !== 'VERIFIED') {
        error_log('PayPal not verified');
        return false;
    }

    if (strpos(strtolower($options['paypal_email']), strtolower($_POST['receiver_email'])) === false) {
        error_log('Wrong merchant');
        return false;
    }

    if ($_POST['payment_status'] == 'Completed') {
        if ($options['price'] != $_POST['mc_gross'] || 'USD' != $_POST['mc_currency']) {
            error_log('Wrong amount or currency');
            return false;
        }
    }

    error_log('PayPal IPN verified');

    return true;
}

if (!pcontents_paypal_verify()) {
    die();
}

//if (function_exists('pcontents_create_user')) {
//    $user = pcontents_create_user();
//} else {
    $user = get_user_by('id', $_POST['custom']);
//}

if (!$user) {
    error_log('User not found, not loaded or not created');
    // Try to send a 404 to PayPal so it can retry
    header('HTTP/1.0 404 Not Found');
    die();
}

switch ($_POST['payment_status']) {

    case 'Completed':
        update_user_meta($user->ID, 'premium_contents_ipn', print_r($_REQUEST, true));
        $duration = (int) $options['duration'];
        if ($duration == 0) $duration = 365;
        update_user_meta($user->ID, 'premium_contents_expire', time() + ($duration * 24 * 60 * 60));
        break;

    case 'Reversed':
    case 'Refunded':
        update_user_meta($user->ID, 'premium_contents_ipn', print_r($_REQUEST, true));
        update_user_meta($user->ID, 'premium_contents_expire', 0);
        break;

    default:
        error_log('IPN payment status not processed');
}
